$(() => {
const dataGrid = $('#gridContainer').dxDataGrid({
dataSource: {
store: {
type: 'odata',
key: 'Task_ID',
url: 'https://js.devexpress.com/Demos/DevAV/odata/Tasks',
},
expand: 'ResponsibleEmployee',
select: [
'Task_ID',
'Task_Subject',
'Task_Start_Date',
'Task_Status',
'Task_Description',
'Task_Completion',
'ResponsibleEmployee/Employee_Full_Name',
],
},
columns: [
{
dataField: 'Task_ID',
width: 80,
}, {
dataField: 'Task_Start_Date',
caption: 'Start Date',
dataType: 'date',
}, {
dataField: 'ResponsibleEmployee.Employee_Full_Name',
caption: 'Assigned To',
allowSorting: false,
}, {
dataField: 'Task_Subject',
caption: 'Subject',
width: 350,
}, {
dataField: 'Task_Status',
caption: 'Status',
},
],
focusedRowEnabled: true,
focusedRowKey: 117,
showBorders: true,
paging: {
pageSize: 10,
},
onFocusedRowChanging(e) {
const rowsCount = e.component.getVisibleRows().length;
const pageCount = e.component.pageCount();
const pageIndex = e.component.pageIndex();
const key = e.event && e.event.key;
if (key && e.prevRowIndex === e.newRowIndex) {
if (e.newRowIndex === rowsCount - 1 && pageIndex < pageCount - 1) {
e.component.pageIndex(pageIndex + 1).done(() => {
e.component.option('focusedRowIndex', 0);
});
} else if (e.newRowIndex === 0 && pageIndex > 0) {
e.component.pageIndex(pageIndex - 1).done(() => {
e.component.option('focusedRowIndex', rowsCount - 1);
});
}
}
},
onFocusedRowChanged(e) {
const taskItem = getTaskDataItem(e.row);
const focusedRowKey = e.component.option('focusedRowKey');
$('#taskSubject').html(taskItem.subject);
$('#taskDetails').html(taskItem.description);
$('#taskStatus').html(taskItem.status);
$('#taskProgress').text(taskItem.progress);
$('#taskId').dxNumberBox('instance').option('value', focusedRowKey);
},
}).dxDataGrid('instance');
$('#taskId').dxNumberBox({
min: 1,
max: 183,
step: 0,
onValueChanged(e) {
if (e.event && e.value > 0) {
dataGrid.option('focusedRowKey', e.value);
}
},
});
$('#autoNavigateCheckboxId').dxCheckBox({
text: 'Auto Navigate To Focused Row',
value: true,
onValueChanged(e) {
dataGrid.option('autoNavigateToFocusedRow', e.value);
},
});
});
function getTaskDataItem(row) {
const rowData = row && row.data;
const taskItem = {
subject: '',
description: '',
status: '',
progress: '',
};
if (rowData) {
taskItem.subject = rowData.Task_Subject;
taskItem.description = rowData.Task_Description;
taskItem.status = rowData.Task_Status;
if (rowData.Task_Completion) {
taskItem.progress = `${rowData.Task_Completion}%`;
}
}
return taskItem;
}
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn3.devexpress.com/jslib/22.2.3/js/dx.all.js"></script>
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="gridContainer"></div>
<div class="task-info">
<div class="info">
<div id="taskSubject"></div>
<p id="taskDetails"></p>
</div>
<div class="progress">
<span id="taskStatus"></span>
<span id="taskProgress"></span>
</div>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="options-container">
<div class="option">
<span>Focused Row Key</span>
<div id="taskId"></div>
</div>
<div class="option">
<div id="autoNavigateCheckboxId"></div>
</div>
</div>
</div>
</div>
</body>
</html>
.task-info {
font-family: Segoe UI;
min-height: 200px;
display: flex;
flex-wrap: nowrap;
border: 2px solid rgba(0, 0, 0, 0.1);
padding: 16px;
box-sizing: border-box;
align-items: baseline;
justify-content: space-between;
}
#taskSubject {
line-height: 29px;
font-size: 18px;
font-weight: bold;
}
#taskDetails {
line-height: 22px;
font-size: 14px;
margin-top: 0;
margin-bottom: 0;
}
.progress {
display: flex;
flex-direction: column;
white-space: pre;
min-width: 105px;
}
.info {
margin-right: 40px;
}
#taskProgress {
line-height: 42px;
font-size: 40px;
font-weight: bold;
}
.options {
margin-top: 20px;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: relative;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
margin-right: 40px;
display: inline-block;
}
.option:last-child {
margin-right: 0;
}
.option > .dx-numberbox {
width: 200px;
display: inline-block;
vertical-align: middle;
}
.option > span {
margin-right: 10px;
}
.options-container {
display: flex;
align-items: center;
}

<dx-data-grid
id="gridContainer"
[dataSource]="dataSource"
[columns]="columns"
[showBorders]="true"
[focusedRowEnabled]="true"
[(focusedRowKey)]="focusedRowKey"
[(autoNavigateToFocusedRow)]="autoNavigateToFocusedRow"
(onFocusedRowChanging)="onFocusedRowChanging($event)"
(onFocusedRowChanged)="onFocusedRowChanged($event)"
>
<dxo-paging [pageSize]="10"> </dxo-paging>
</dx-data-grid>
<div class="task-info">
<div class="info">
<div id="taskSubject">{{ taskSubject }}</div>
<p id="taskDetails" [innerHtml]="taskDetailsHtml"></p>
</div>
<div class="progress">
<span id="taskStatus">{{ taskStatus }}</span>
<span id="taskProgress">{{ taskProgress }}</span>
</div>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="options-container">
<div class="option">
<span>Focused Row Key</span>
<dx-number-box
id="taskId"
min="1"
max="183"
step="0"
[(value)]="focusedRowKey"
[inputAttr]="{ 'aria-label': 'Focused Row Key' }"
>
</dx-number-box>
</div>
<div class="option">
<dx-check-box
[text]="'Auto Navigate To Focused Row'"
[(value)]="autoNavigateToFocusedRow"
>
</dx-check-box>
</div>
</div>
</div>
import {
NgModule, Component, ViewChild, enableProdMode,
} from '@angular/core';
import {
BrowserModule, BrowserTransferStateModule, DomSanitizer, SafeHtml,
} from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import {
DxDataGridComponent,
DxNumberBoxComponent,
DxDataGridModule,
DxNumberBoxModule,
DxCheckBoxModule,
} from 'devextreme-angular';
import 'devextreme/data/odata/store';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
preserveWhitespaces: true,
})
export class AppComponent {
@ViewChild(DxDataGridComponent, { static: false }) dataGrid: DxDataGridComponent;
@ViewChild(DxNumberBoxComponent, { static: false }) numberBox: DxNumberBoxComponent;
columns: any;
dataSource: any;
isReady: boolean;
taskSubject: string;
taskDetailsHtml: SafeHtml;
taskStatus: string;
taskProgress: string;
focusedRowKey = 117;
autoNavigateToFocusedRow = true;
constructor(private sanitizer: DomSanitizer) {
this.dataSource = {
store: {
type: 'odata',
key: 'Task_ID',
url: 'https://js.devexpress.com/Demos/DevAV/odata/Tasks',
},
expand: 'ResponsibleEmployee',
select: [
'Task_ID',
'Task_Subject',
'Task_Start_Date',
'Task_Status',
'Task_Description',
'Task_Completion',
'ResponsibleEmployee/Employee_Full_Name',
],
};
this.columns = [
{
dataField: 'Task_ID',
width: 80,
}, {
caption: 'Start Date',
dataField: 'Task_Start_Date',
dataType: 'date',
}, {
caption: 'Assigned To',
dataField: 'ResponsibleEmployee.Employee_Full_Name',
cssClass: 'employee',
allowSorting: false,
}, {
caption: 'Subject',
dataField: 'Task_Subject',
width: 350,
}, {
caption: 'Status',
dataField: 'Task_Status',
},
];
}
onFocusedRowChanging(e) {
const rowsCount = e.component.getVisibleRows().length;
const pageCount = e.component.pageCount();
const pageIndex = e.component.pageIndex();
const key = e.event && e.event.key;
if (key && e.prevRowIndex === e.newRowIndex) {
if (e.newRowIndex === rowsCount - 1 && pageIndex < pageCount - 1) {
e.component.pageIndex(pageIndex + 1).done(() => {
e.component.option('focusedRowIndex', 0);
});
} else if (e.newRowIndex === 0 && pageIndex > 0) {
e.component.pageIndex(pageIndex - 1).done(() => {
e.component.option('focusedRowIndex', rowsCount - 1);
});
}
}
}
onFocusedRowChanged(e) {
const rowData = e.row && e.row.data;
if (rowData) {
this.taskSubject = rowData.Task_Subject;
this.taskDetailsHtml = this.sanitizer.bypassSecurityTrustHtml(rowData.Task_Description);
this.taskStatus = rowData.Task_Status;
this.taskProgress = rowData.Task_Completion ? `${rowData.Task_Completion}` + '%' : '';
}
}
}
@NgModule({
imports: [
BrowserModule,
BrowserTransferStateModule,
DxDataGridModule,
DxNumberBoxModule,
DxCheckBoxModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
.task-info {
font-family: Segoe UI;
min-height: 200px;
display: flex;
flex-wrap: nowrap;
border: 2px solid rgba(0, 0, 0, 0.1);
padding: 16px;
box-sizing: border-box;
align-items: baseline;
justify-content: space-between;
}
#taskSubject {
line-height: 29px;
font-size: 18px;
font-weight: bold;
}
#taskDetails {
line-height: 22px;
font-size: 14px;
margin-top: 0;
margin-bottom: 0;
}
.progress {
display: flex;
flex-direction: column;
white-space: pre;
min-width: 105px;
}
.info {
margin-right: 40px;
}
#taskProgress {
line-height: 42px;
font-size: 40px;
font-weight: bold;
}
.options {
margin-top: 20px;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: relative;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
margin-right: 40px;
display: inline-block;
}
.option:last-child {
margin-right: 0;
}
.option > .dx-numberbox {
width: 200px;
display: inline-block;
vertical-align: middle;
}
.option > span {
margin-right: 10px;
}
.options-container {
display: flex;
align-items: center;
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme-aspnet-data-nojquery': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'@angular/core': 'npm:@angular/core@12.2.17',
'@angular/platform-browser': 'npm:@angular/platform-browser@12.2.17',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.17',
'@angular/forms': 'npm:@angular/forms@12.2.17',
'@angular/common': 'npm:@angular/common@12.2.17',
'@angular/compiler': 'npm:@angular/compiler@12.2.17',
'tslib': 'npm:tslib@2.3.1/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@2.9.0/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@23.1.5/cjs',
'devextreme/bundles/dx.all': 'npm:devextreme@23.1.5/bundles/dx.all.js',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.6.2/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.1',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.48',
'devextreme-angular': 'npm:devextreme-angular@23.1.5',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
'npm:@angular/*/package.json',
'npm:@angular/common@12.2.17/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devextreme-angular@23.1.5/*/package.json',
'npm:devextreme-angular@23.1.5/ui/*/package.json',
'npm:devextreme-angular@23.1.5/package.json',
'npm:devexpress-diagram@2.2.1/package.json',
'npm:devexpress-gantt@4.1.48/package.json',
],
};
System.config(window.config);
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.12.0/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

import React from 'react';
import { DataGrid, Column, Paging } from 'devextreme-react/data-grid';
import { NumberBox } from 'devextreme-react/number-box';
import { CheckBox } from 'devextreme-react/check-box';
import 'devextreme/data/odata/store';
const dataSourceOptions = {
store: {
type: 'odata',
key: 'Task_ID',
url: 'https://js.devexpress.com/Demos/DevAV/odata/Tasks',
},
expand: 'ResponsibleEmployee',
select: [
'Task_ID',
'Task_Subject',
'Task_Start_Date',
'Task_Status',
'Task_Description',
'Task_Completion',
'ResponsibleEmployee/Employee_Full_Name',
],
};
class App extends React.Component {
constructor(props) {
super(props);
this.state = {
taskSubject: '',
taskDetails: '',
taskStatus: '',
taskProgress: '',
focusedRowKey: 117,
autoNavigateToFocusedRow: true,
};
this.onFocusedRowChanged = this.onFocusedRowChanged.bind(this);
this.onTaskIdChanged = this.onTaskIdChanged.bind(this);
this.onAutoNavigateToFocusedRowChanged = this.onAutoNavigateToFocusedRowChanged.bind(this);
}
onTaskIdChanged(e) {
if (e.event && e.value > 0) {
this.setState({ focusedRowKey: e.value });
}
}
onFocusedRowChanging(e) {
const rowsCount = e.component.getVisibleRows().length;
const pageCount = e.component.pageCount();
const pageIndex = e.component.pageIndex();
const key = e.event && e.event.key;
if (key && e.prevRowIndex === e.newRowIndex) {
if (e.newRowIndex === rowsCount - 1 && pageIndex < pageCount - 1) {
e.component.pageIndex(pageIndex + 1).done(() => {
e.component.option('focusedRowIndex', 0);
});
} else if (e.newRowIndex === 0 && pageIndex > 0) {
e.component.pageIndex(pageIndex - 1).done(() => {
e.component.option('focusedRowIndex', rowsCount - 1);
});
}
}
}
onFocusedRowChanged(e) {
const dataRow = e.row && e.row.data;
const progress = dataRow && dataRow.Task_Completion ? `${dataRow.Task_Completion}%` : '';
this.setState({
taskSubject: dataRow && dataRow.Task_Subject,
taskDetails: dataRow && dataRow.Task_Description,
taskStatus: dataRow && dataRow.Task_Status,
taskProgress: progress,
focusedRowKey: e.component.option('focusedRowKey'),
});
}
onAutoNavigateToFocusedRowChanged(e) {
this.setState({ autoNavigateToFocusedRow: e.value });
}
render() {
return (
<div>
<DataGrid
id="gridContainer"
dataSource={dataSourceOptions}
focusedRowEnabled={true}
focusedRowKey={this.state.focusedRowKey}
autoNavigateToFocusedRow={this.state.autoNavigateToFocusedRow}
onFocusedRowChanging={this.onFocusedRowChanging}
onFocusedRowChanged={this.onFocusedRowChanged}
showBorders={true}>
<Paging defaultPageSize={10} />
<Column
dataField="Task_ID"
width={80} />
<Column
caption="Start Date"
dataField="Task_Start_Date"
dataType="date" />
<Column
caption="Assigned To"
dataField="ResponsibleEmployee.Employee_Full_Name"
dataType="date"
allowSorting={false}
/>
<Column
caption="Subject"
dataField="Task_Subject"
width={350} />
<Column
caption="Status"
dataField="Task_Status" />
</DataGrid>
<div className="task-info">
<div className="info">
<div id="taskSubject">{this.state.taskSubject}</div>
<p id="taskDetails" dangerouslySetInnerHTML={{ __html: this.state.taskDetails }}></p>
</div>
<div className="progress">
<span id="taskStatus">{this.state.taskStatus}</span>
<span id="taskProgress">{this.state.taskProgress}</span>
</div>
</div>
<div className="options">
<div className="caption">Options</div>
<div className="options-container">
<div className="option">
<span>Focused Row Key </span>
<NumberBox
id="taskId"
min={1}
max={183}
step={0}
value={this.state.focusedRowKey}
onValueChanged={this.onTaskIdChanged}>
</NumberBox>
</div>
<div className="option">
<CheckBox
text="Auto Navigate To Focused Row"
value={this.state.autoNavigateToFocusedRow}
onValueChanged={this.onAutoNavigateToFocusedRowChanged}>
</CheckBox>
</div>
</div>
</div>
</div>
);
}
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.5/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.task-info {
font-family: Segoe UI;
min-height: 200px;
display: flex;
flex-wrap: nowrap;
border: 2px solid rgba(0, 0, 0, 0.1);
padding: 16px;
box-sizing: border-box;
align-items: baseline;
justify-content: space-between;
}
#taskSubject {
line-height: 29px;
font-size: 18px;
font-weight: bold;
}
#taskDetails {
line-height: 22px;
font-size: 14px;
margin-top: 0;
margin-bottom: 0;
}
.progress {
display: flex;
flex-direction: column;
white-space: pre;
min-width: 105px;
}
.info {
margin-right: 40px;
}
#taskProgress {
line-height: 42px;
font-size: 40px;
font-weight: bold;
}
.options {
margin-top: 20px;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: relative;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
margin-right: 40px;
display: inline-block;
}
.option:last-child {
margin-right: 0;
}
.option > .dx-numberbox {
width: 200px;
display: inline-block;
vertical-align: middle;
}
.option > span {
margin-right: 10px;
}
.options-container {
display: flex;
align-items: center;
}
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
'devextreme-aspnet-data-nojquery': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@2.9.0/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.5/cjs',
'devextreme-react': 'npm:devextreme-react@22.2.5',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.20/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.72/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.42/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);

<template>
<div>
<DxDataGrid
id="gridContainer"
:ref="dataGridRefName"
:data-source="dataSource"
:columns="columns"
:show-borders="true"
:focused-row-enabled="true"
:auto-navigate-to-focused-row="autoNavigateToFocusedRow"
v-model:focused-row-key="focusedRowKey"
@focused-row-changing="onFocusedRowChanging"
@focused-row-changed="onFocusedRowChanged"
>
<DxPaging :page-size="10"/>
</DxDataGrid>
<div class="task-info">
<div class="info">
<div id="taskSubject">{{ taskSubject }}</div>
<p
id="taskDetails"
v-html="taskDetails"
/>
</div>
<div class="progress">
<span id="taskStatus">{{ taskStatus }}</span>
<span id="taskProgress">{{ taskProgress }}</span>
</div>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="options-container">
<div class="option">
<span>Focused Row Key </span>
<DxNumberBox
id="taskId"
:ref="taskIdEditorRefName"
:min="1"
:max="183"
:step="0"
v-model:value="focusedRowKey"
/>
</div>
<div class="option">
<DxCheckBox
:text="'Auto Navigate To Focused Row'"
v-model:value="autoNavigateToFocusedRow"
/>
</div>
</div>
</div>
</div>
</template>
<script>
import 'devextreme/data/odata/store';
import { DxDataGrid, DxPager, DxPaging } from 'devextreme-vue/data-grid';
import DxNumberBox from 'devextreme-vue/number-box';
import DxCheckBox from 'devextreme-vue/check-box';
const dataGridRefName = 'dataGrid';
const taskIdEditorRefName = 'taskIdEditor';
export default {
components: {
DxDataGrid,
DxPager,
DxPaging,
DxNumberBox,
DxCheckBox,
},
data() {
return {
taskIdEditorRefName,
dataGridRefName,
taskSubject: '',
taskDetails: '',
taskStatus: '',
taskProgress: '',
dataSource: {
store: {
type: 'odata',
key: 'Task_ID',
url: 'https://js.devexpress.com/Demos/DevAV/odata/Tasks',
},
expand: 'ResponsibleEmployee',
select: [
'Task_ID',
'Task_Subject',
'Task_Start_Date',
'Task_Status',
'Task_Description',
'Task_Completion',
'ResponsibleEmployee/Employee_Full_Name',
],
},
focusedRowKey: 117,
autoNavigateToFocusedRow: true,
columns: [
{
dataField: 'Task_ID',
width: 80,
}, {
caption: 'Start Date',
dataField: 'Task_Start_Date',
dataType: 'date',
}, {
caption: 'Assigned To',
dataField: 'ResponsibleEmployee.Employee_Full_Name',
cssClass: 'employee',
allowSorting: false,
}, {
caption: 'Subject',
dataField: 'Task_Subject',
width: 350,
}, {
caption: 'Status',
dataField: 'Task_Status',
},
],
isReady: false,
};
},
methods: {
onFocusedRowChanging(e) {
const pageSize = e.component.pageSize();
const pageIndex = e.component.pageIndex();
const isLoading = e.component.getController('data').isLoading();
const key = e.event && e.event.key;
if (!isLoading) {
if (key && e.prevRowIndex === e.newRowIndex) {
if (e.newRowIndex === pageSize - 1) {
e.component.pageIndex(pageIndex + 1).done(() => {
e.component.option('focusedRowIndex', 0);
});
} else if (e.newRowIndex === 0) {
e.component.pageIndex(pageIndex - 1).done(() => {
e.component.option('focusedRowIndex', pageSize - 1);
});
}
}
}
},
onFocusedRowChanged(e) {
const data = e.row && e.row.data;
this.taskSubject = data && data.Task_Subject;
this.taskDetails = data && data.Task_Description;
this.taskStatus = data && data.Task_Status;
this.taskProgress = data && data.Task_Completion ? `${data.Task_Completion}%` : '';
this.focusedRowKey = e.component.option('focusedRowKey');
},
},
};
</script>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app" />
</div>
</body>
</html>
.task-info {
font-family: Segoe UI;
min-height: 200px;
display: flex;
flex-wrap: nowrap;
border: 2px solid rgba(0, 0, 0, 0.1);
padding: 16px;
box-sizing: border-box;
align-items: baseline;
justify-content: space-between;
}
#taskSubject {
line-height: 29px;
font-size: 18px;
font-weight: bold;
}
#taskDetails {
line-height: 22px;
font-size: 14px;
margin-top: 0;
margin-bottom: 0;
}
.progress {
display: flex;
flex-direction: column;
white-space: pre;
min-width: 105px;
}
.info {
margin-right: 40px;
}
#taskProgress {
line-height: 42px;
font-size: 40px;
font-weight: bold;
}
.options {
margin-top: 20px;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: relative;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
margin-right: 40px;
display: inline-block;
}
.option:last-child {
margin-right: 0;
}
.option > .dx-numberbox {
width: 200px;
display: inline-block;
vertical-align: middle;
}
.option > span {
margin-right: 10px;
}
.options-container {
display: flex;
align-items: center;
}
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme-aspnet-data-nojquery': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'vue': 'npm:vue@3.2.41/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js',
'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@2.8.6/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.3/cjs',
'devextreme-vue': 'npm:devextreme-vue@22.2.3',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.20/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.65/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.37/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.7.1/standalone.js',
'prettier/parser-html': 'npm:prettier@2.7.1/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);